﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using Pokkt;

public class OfferwallOperations : MonoBehaviour
{
	// exposed properties
	public GameObject ScreenManagerGO = null;
	public Text PointsEarned;
	public Text StatusMessage;

	// internal states
	private string _assetValue = "0";
	private int _totalPointsEarned = 0;

	void Awake()
	{
		// this will be a unique id per user from developer side
		// developer is free to choose any String data point.
		PokktManager.GetInstance().SetThirdPartyUserId("123456");

		// handle pokkt offerwall events
		PokktManager.GetInstance().Dispathcer.CoinResponseEvent += (string message) =>
		{
			_totalPointsEarned += int.Parse(message);
			
			PointsEarned.text = "Points Earned: " + _totalPointsEarned.ToString();
			StatusMessage.text = "Points earned from last operation: " + message;
		};

		PokktManager.GetInstance().Dispathcer.CoinResponseWithTransIdEvent += (string message) =>
		{
			string[] items = message.Split(new char[] { ',', ' ' }, System.StringSplitOptions.RemoveEmptyEntries);
			string points = items[0];
			string transId = items[1];

			_totalPointsEarned += int.Parse(points);

			PointsEarned.text = "Points Earned: " + _totalPointsEarned.ToString();
			StatusMessage.text = "Points earned from transaction id: " + transId + ", earned points: " + points;
		};

		PokktManager.GetInstance().Dispathcer.CoinResponseFailedEvent += (string message) =>
		{
			StatusMessage.text = message;
		};

		PokktManager.GetInstance().Dispathcer.CampaignAvailabilityEvent += (string message) =>
		{
			StatusMessage.text = message;
		};

		PokktManager.GetInstance().Dispathcer.OfferwallClosedEvent += (string message) =>
		{
			StatusMessage.text = message;
		};
	}

	void Start()
	{
	}
	
	void Update()
	{
		if (Input.GetKeyDown(KeyCode.Escape))
			ScreenManagerGO.GetComponent<ScreenManager>().OpenScreen("CampaignSelectorScreen");
	}
	
	void OnApplicationPause(bool paused)
	{
		if (!paused)
		{
			PokktManager.GetInstance().GetPendingCoins();
			PokktManager.GetInstance().CheckOfferwallCampaign();
		}
	}

	public void GetOfferwallAny()
	{
		PokktManager.GetInstance().GetFreeCoins();
	}

	public void GetOfferwallFixed()
	{
		PokktManager.GetInstance().GetFreeCoins(_assetValue);
	}

	public void GetPendingCoins()
	{
		PokktManager.GetInstance().GetPendingCoins();
	}

	public void SetAssetValue(InputField inputField)
	{
		_assetValue = inputField.text;
	}
}
